---
# tasks file for roles/my-ansible-role-kubernetes
- name: Install `kubectl` with `--classic` option
  become: true
  community.general.snap:
    name: kubectl
    classic: true

- name: Install krew package manager for kubectl
  script: bin/install_krew.sh
  args:
    creates: ~/.krew/
  register: krew

- name: Download list of krew plugins
  script: /snap/bin/kubectl krew update
  when: krew is succeeded

- name: Install krew plugins
  script: '/snap/bin/kubectl krew install {{ item }}'
  loop: '{{ packages }}'

- name: Upgrade krew plugins
  script: /snap/bin/kubectl krew upgrade
  when: krew is succeeded

- name: Download Helm Key
  get_url:
    url: 'https://baltocdn.com/helm/signing.asc'
    dest: '/tmp/helm_signing.asc'
  register: helm_key_download

- name: Add Helm Key
  become: true
  apt_key:
    file: '/tmp/helm_signing.asc'
    state: present
  when: helm_key_download is succeeded
  register: helm_key

- name: Create Helm APT Sources List
  become: true
  copy:
    content: 'deb https://baltocdn.com/helm/stable/debian/ all main'
    dest: /etc/apt/sources.list.d/helm-stable-debian.list
    force: true
    group: sys
    owner: root
    mode: 0644
  when: helm_key is succeeded
  register: helm_sources_list

- name: Update apt cache
  become: true
  apt:
    update_cache: yes
  when: helm_sources_list is succeeded
  register: apt_cache

- name: Install Helm
  become: true
  apt:
    name: helm
    state: present
  when: helm_sources_list is succeeded and apt_cache is succeeded
